<?php

if (class_exists('GFAddOn')) {
class GFQueriesAddon extends GFAddOn {
	protected $_slug = 'gf-queries';
	protected $_title = 'GF Queries';
	protected $_short_title = 'GF Queries';
	private static $_instance = null;

	public static function get_instance() {
		if ( self::$_instance == null ) {
			self::$_instance = new GFQueriesAddon();
		}
		return self::$_instance;
	}

	public function init_admin() {
		parent::init_admin();
		//add actions to allow the payment status to be modified
		//add_action( 'gform_payment_status', array( $this, 'admin_edit_payment_status' ), 3, 3 );
		//add_action( 'gform_payment_date', array( $this, 'admin_edit_payment_date' ), 3, 3 );
		//add_action( 'gform_payment_transaction_id', array( $this, 'admin_edit_payment_transaction_id' ), 3, 3 );
		//add_action( 'gform_payment_amount', array( $this, 'admin_edit_payment_amount' ), 3, 3 );
		//add_action( 'gform_after_update_entry', array( $this, 'admin_update_payment' ), 4, 2 );
		//add_filter( 'gform_addon_navigation', array( $this, 'maybe_create_menu' ) );
	}

	/*public function plugin_page() {
		echo 'GF Queries';
	}*/
	public function plugin_settings_fields() {
		return array(
			array(
				'title'       => 'GF Queries',
				'description' => '',
				'fields'      => array(
					array(
						'name'    => 'gf_queries_apikey',
						'label'   => esc_html__( 'GF Queries ApiKey', 'gf_queries' ),
						'type'  => 'text',
						'default_value' => GFQueries::apikey()
					),
					array(
						'type' => 'save',
						'messages' => array(
							'success' => esc_html__( 'Settings have been updated.', 'gf_queries' )
						),
					),
				),
			),
		);
	}
	public function form_settings_fields($form) {
		return array(
			array(
				'title'  => esc_html__('GF Queries', $this->_slug),
				'fields' => array(
					array(
						'label'   => esc_html__('Enable GF Queries', $this->_slug),
						'type'    => 'checkbox',
						'name'    => 'enabled',
						'tooltip' => esc_html__('Enable GF Queries for this Gravity Form', $this->_slug),
						'choices' => array(
							array(
								'label' => esc_html__( 'Enabled', $this->_slug),
								'name'  => 'enabled'
							)
						)
					),
					array(
						'label'   => esc_html__('Enable Analytics', $this->_slug),
						'type'    => 'checkbox',
						'name'    => 'analytics',
						'tooltip' => esc_html__('Enable Analytics for this Gravity Form', $this->_slug),
						'choices' => array(
							array(
								'label' => esc_html__( 'Analytics', $this->_slug),
								'name'  => 'analytics'
							)
						)
					),
					array(
						'label'     => esc_html__('Field Mapping', $this->_slug),
						'type'      => 'field_map',
						'name'      => 'fields',
						'tooltip' => esc_html__('Map fields between this form and GF Queries', $this->_slug),
						'field_map' => array(
							array(
								'name'          => 'firstname',
								'label'         => esc_html__( 'First Name', $this->_slug),
								'required'      => false,
								'field_type'    => array( 'text', 'name' ),
								'default_value' => ''
							),
							array(
								'name'          => 'lastname',
								'label'         => esc_html__( 'Last Name', $this->_slug),
								'required'      => false,
								'field_type'    => array( 'text', 'name' ),
								'default_value' => ''
							),
							array(
								'name'          => 'email',
								'label'         => esc_html__( 'Email', $this->_slug),
								'required'      => false,
								'field_type'    => array( 'text', 'email' ),
								'default_value' => ''
							),
							array(
								'name'          => 'phone',
								'label'         => esc_html__( 'Phone', $this->_slug),
								'required'      => false,
								'field_type'    => array( 'text', 'phone' ),
								'default_value' => ''
							),
							array(
								'name'          => 'address1',
								'label'         => esc_html__( 'Street Address', $this->_slug),
								'required'      => false,
								'field_type'    => array( 'text', 'address' ),
								'default_value' => ''
							),
							array(
								'name'          => 'address2',
								'label'         => esc_html__( 'Address 2', $this->_slug),
								'required'      => false,
								'field_type'    => array( 'text', 'address' ),
								'default_value' => ''
							),
							array(
								'name'          => 'city',
								'label'         => esc_html__( 'City', $this->_slug),
								'required'      => false,
								'field_type'    => array( 'text', 'address' ),
								'default_value' => ''
							),
							array(
								'name'          => 'state',
								'label'         => esc_html__( 'State', $this->_slug),
								'required'      => false,
								'field_type'    => array( 'text', 'address' ),
								'default_value' => ''
							),
							array(
								'name'          => 'zip',
								'label'         => esc_html__( 'Zip', $this->_slug),
								'required'      => false,
								'field_type'    => array( 'text', 'address' ),
								'default_value' => ''
							),
							array(
								'name'          => 'country',
								'label'         => esc_html__( 'Country', $this->_slug),
								'required'      => false,
								'field_type'    => array( 'text', 'address' ),
								'default_value' => ''
							),
							array(
								'name'          => 'description',
								'label'         => esc_html__( 'Description', $this->_slug),
								'required'      => false,
								'field_type'    => array( 'text', 'hidden' ),
								'default_value' => ''
							),
							array(
								'name'          => 'total',
								'label'         => esc_html__( 'Total', $this->_slug),
								'required'      => false,
								'field_type'    => array( 'total', 'price', 'product' ),
								'default_value' => ''
							),
							array(
								'name'          => 'shipping',
								'label'         => esc_html__( 'Shipping', $this->_slug),
								'required'      => false,
								'field_type'    => array( 'shipping' ),
								'default_value' => ''
							),
							array(
								'name'          => 'quantity',
								'label'         => esc_html__( 'Quantity', $this->_slug),
								'required'      => false,
								'field_type'    => array( 'quantity' ),
								'default_value' => ''
							),
							array(
								'name'          => 'product',
								'label'         => esc_html__( 'Product', $this->_slug),
								'required'      => false,
								'field_type'    => array( 'product' ),
								'default_value' => ''
							)
						)
					)
				)
			)
		);
	}
}
}
